.release:
  stage: release

.release_development:
  rules:
  - if: $S3_ENDPOINT_URL && $S3_BUCKET && $S3_ACCESS_KEY_ID && $S3_SECRET_ACCESS_KEY && $CI_PIPELINE_SOURCE == "merge_request_event"

.release_beta:
  rules:
  - if: $S3_ENDPOINT_URL && $S3_BUCKET && $S3_ACCESS_KEY_ID && $S3_SECRET_ACCESS_KEY && $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PROJECT_PATH == "maczukin.dev/terraform/ci"

.release_stable:
  rules:
  - if: $CI_COMMIT_TAG =~ /^v[0-9]+\.[0-9]+\.[0-9]+$/ && $CI_PROJECT_PATH == "maczukin.dev/terraform/ci"

.release_s3_base:
  before_script:
  - aws configure set aws_access_key_id ${S3_ACCESS_KEY_ID}
  - aws configure set aws_secret_access_key ${S3_SECRET_ACCESS_KEY}
  - aws configure set default.region us-east-1
  - aws configure set default.s3.signature_version s3v4

.release_s3:
  extends:
  - .release_s3_base
  script:
  - make release_s3

.remove_release_s3:
  extends:
  - .release_s3_base
  script:
  - make remove_s3_release

release development S3:
  extends:
  - .release
  - .release_development
  - .release_s3
  environment:
    name: development/S3/${CI_COMMIT_REF_NAME}
    url: ${S3_ENDPOINT_URL}/${S3_BUCKET}/${CI_COMMIT_REF_NAME}/index.html
    on_stop: stop release development S3

stop release development S3:
  extends:
  - .release
  - .release_development
  - .remove_release_s3
  environment:
    name: development/S3/${CI_COMMIT_REF_NAME}
    action: stop

release beta S3:
  extends:
  - .release
  - .release_beta
  - .release_s3
  environment:
    name: beta/S3
    url: ${S3_ENDPOINT_URL}/${S3_BUCKET}/${CI_COMMIT_REF_NAME}/index.html

pages:
  extends:
  - .release
  - .release_stable
  script:
  - cp -a build public
  artifacts:
    paths:
    - public
  environment:
    name: stable/S3
    url: ${CI_PAGES_URL}/index.html

